package command;

import java.util.ArrayList;

public class CarModelChecker {

    private ArrayList<CarAdjustment> carAdjustments; //Armazena uma lista de ajustes
    private ArrayList<Boolean> executedAdjustments; //Armazena se o ajuste na posição equivalente foi executado
    private int adjustmentsLength; //Armazena o tamanho da lista de ajustes

    public CarModelChecker(){
        carAdjustments = new ArrayList<>();
        executedAdjustments = new ArrayList<>();
        adjustmentsLength = 0;
    }

    //Adiciona um ajuste à lista
    public void addAdjustment(CarAdjustment adjustment){
        carAdjustments.add(adjustment);
        executedAdjustments.add(false);
        adjustmentsLength++;
    }

    //Reseta os ajustes, limpando as listas
    public void resetAdjustment(){
        carAdjustments.clear();
        executedAdjustments.clear();
        adjustmentsLength = 0;
    }

    //Percorre a lista, executando os ajustes salvos.
    public void doAdjustments(){
        for(int iterator = 0; iterator < adjustmentsLength; iterator++){
            executedAdjustments.set(iterator, carAdjustments.get(iterator).execute());
        }
    }

    //Percorre a lista inversamente, revertendo os ajustes executados.
    public void undoAdjustments(){
        for (int iterator = adjustmentsLength-1; iterator >=0; iterator--){
            if(executedAdjustments.get(iterator)){
                carAdjustments.get(iterator).unexecute();
                executedAdjustments.set(iterator, false);
            }
        }
    }
}
