package command;

//Classe responsável por criar os objetos que realizam ajustes
//na instância de CarModel armazenada em seus atributos.
public class CarModelDefiner {

    private CarModel carModel;

    public CarModelDefiner(CarModel carModel){
        this.carModel = carModel;
    }

    public CarAdjustment createHeightWidthAdjustment(float heigth,
                                                     float width){
        return new HeightWidthAdjustment(heigth, width, carModel);
    }

    public CarAdjustment createCargoVolumeAdjustment(float cargoVolume){
        return new CargoVolumeAdjustment(cargoVolume, carModel);
    }

    public CarAdjustment createWheelbaseAdjustment(float wheelbase){
        return new WheelbaseAdjustment(wheelbase, carModel);
    }

    public CarModel getCarModel() {
        return carModel;
    }
}
