package command;

public class HeightWidthAdjustment extends CarAdjustmentImpl{
    private final float heightAdd;
    private final float widthAdd;

    //Recebe como parâmetro no construtor o quanto os atributos
    //devem ser ajustados e o objeto alvo do ajuste
    public HeightWidthAdjustment(float height, float width, CarModel model){
        super(model);
        this.heightAdd = height;
        this.widthAdd = width;
    }

    //Executa o ajuste no objeto recebido
    public boolean execute(){
        float height = carModel.getHeight();
        float width = carModel.getWidth();
        carModel.setHeight(height + heightAdd);
        carModel.setWidth(width + widthAdd);
        return true;
    }

    //Reverte o ajuste no objeto recebido
    public void unexecute(){
        float height = carModel.getHeight();
        float width = carModel.getWidth();
        carModel.setHeight(height - heightAdd);
        carModel.setWidth(width - widthAdd);
    }

}
