package command;

public class Main {
    public static void main(String[] args) {

        CarModel carModel = new CarModel();
        carModel.setHeight(1.4f);
        carModel.setWidth(1.8f);
        carModel.setCargoVolume(1.3f);
        carModel.setWheelbase(3.9f);

        CarModelDefiner carModelDefiner = new CarModelDefiner(carModel);

        System.out.println("Model before adjustments: \n" + carModel.getCarInfo() + "\n\n");

        CarModelChecker carModelChecker = new CarModelChecker();
        carModelChecker.addAdjustment(
                carModelDefiner.createHeightWidthAdjustment(0.4f, -0.6f)
        );
        carModelChecker.addAdjustment(
                carModelDefiner.createCargoVolumeAdjustment(1)
        );
        carModelChecker.addAdjustment(
                carModelDefiner.createWheelbaseAdjustment(-1.8f)
        );

        carModelChecker.doAdjustments();

        System.out.println("Car after adjustments: \n" + carModel.getCarInfo() + "\n\n");

        if(!testModel(carModel)) {
            carModelChecker.undoAdjustments();

            System.out.println("Car after test failure: \n" + carModel.getCarInfo() + "\n\n");

        }
    }

    public static boolean testModel(CarModel carModel){
        float value = (carModel.getWheelbase()/carModel.getHeight())
                      * carModel.getWidth();

        return value < 2*carModel.getWheelbase()
                && value > 2.5*carModel.getCargoVolume();
    }
}
