package command;

public class WheelbaseAdjustment extends CarAdjustmentImpl {
    private final float wheelbaseAdd;

    //Recebe como parâmetro no construtor o quanto o atributo
    //deve ser ajustado e o objeto alvo do ajuste
    public WheelbaseAdjustment(float wheelbase, CarModel model){
        super(model);
        this.wheelbaseAdd = wheelbase;
    }

    //Executa o ajuste no objeto recebido
    public boolean execute(){
        float wheelbase = carModel.getWheelbase();
        carModel.setWheelbase(wheelbase + wheelbaseAdd);
        return true;
    }

    //Reverte o ajuste no objeto recebido
    public void unexecute(){
        float wheelbase = carModel.getWheelbase();
        carModel.setWheelbase(wheelbase - wheelbaseAdd);
    }
}
